%define anolis_release 1

%global realname rebar
%global upstream basho
%global debug_package %{nil}
%global commit 365ac649dc818619757f96a699ddb174f004cff9
%global patchnumber 0

# Set this to true when starting a rebuild of the whole erlang stack. There's
# a cyclical dependency between erlang-rebar and erlang-getopt so this package
# (rebar) needs to get built first in bootstrap mode.
%global need_bootstrap_set 1

%{!?need_bootstrap: %global need_bootstrap  %{need_bootstrap_set}}


Name:		erlang-%{realname}
Version:	2.6.1
Release:	%{anolis_release}%{?dist}
Summary:	Erlang Build Tools
Group:		Development/Tools
License:	MIT
URL:		https://github.com/rebar/rebar
# wget --content-disposition https://github.com/rebar/rebar/archive/365ac649dc818619757f96a699ddb174f004cff9/rebar-365ac649dc818619757f96a699ddb174f004cff9.tar.gz
Source0:	https://github.com/rebar/rebar/archive/%{commit}/%{realname}-%{commit}.tar.gz
Source1:	rebar.escript
Patch1:		rebar-0001-Don-t-load-templates-from-the-bundle.patch
Patch2:		rebar-0002-Remove-bundled-mustache.patch
# The bundled getopt is necessary to do the initial bootstrap since
# erlang-getopt requires erlang-rebar to build and vice versa.
%if 0%{?need_bootstrap} < 1
Patch3:		rebar-0003-Remove-bundled-getopt.patch
%endif
# Will be proposed for inclusion
Patch4:		rebar-0004-Allow-discarding-building-ports.patch
Patch5:		rebar-0005-Check-system-wide-libdir-in-case-of-source-based-dep.patch
Patch6:		rebar-0006-Remove-any-traces-of-long-time-obsolete-escript-fold.patch

%if 0%{?need_bootstrap} < 1
BuildRequires:	erlang-rebar
%else
BuildRequires:	erlang
%endif
# FIXME should be removed in the next builds - it will be picked up
# automatically
BuildRequires:	erlang-common_test
BuildRequires:	erlang-parsetools
BuildRequires:	erlang-rpm-macros

Requires:	erlang-common_test

# Requires for port compiling - no direct references in Rebar's src/*.erl files
Requires:	erlang-erl_interface

# Autochecker picks up a missing dependency in R16 -
# eunit_test:function_wrapper/2.  This function was removed in R16, and rebar
# contains a workaround for that. So no need to worry about that.

# This one cannot be picked up automatically
Requires:	erlang-parsetools
Requires:	erlang-rpm-macros
Provides:	%{realname} = %{version}-%{release}


%description
Erlang Build Tools.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.


%prep
%setup -q -n %{realname}-%{commit}
%patch1 -p1 -b .dont_load_templates
%patch2 -p1 -b .remove_bundled_mustache
%if 0%{?need_bootstrap} < 1
%patch3 -p1 -b .remove_bundled_getopt
%endif
%patch4 -p1 -b .allow_discarding_ports
%patch5 -p1 -b .use_locally_installed
%patch6 -p1 -b .remove_escript_foldl_3


%build
%if 0%{?need_bootstrap} < 1
rebar compile -v
%else
./bootstrap
./rebar compile -v
%endif


%install
install -D -p -m 0755 %{SOURCE1} %{buildroot}%{_bindir}/rebar
mkdir -p %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin
mkdir -p %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/include
install -m 644 ebin/%{realname}.app %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin
install -m 644 ebin/*.beam %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin
install -m 644 include/*.hrl %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/include
cp -a priv %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/

%check
#rebar eunit -v


%files
%doc rebar.config.sample
%license LICENSE
%{_bindir}/rebar
%{_libdir}/erlang/lib/%{realname}-%{version}

%files doc
%doc README.md THANKS

%changelog
* Fri Sep 01 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.6.1-1
- Init upstream from version 2.6.1
